package pl.edu.pjwstk.yaod.atoms;

/**
 * Klasa reprezentujaca atom, ktorego wartoscia sa dane binarne (np. zdjecie).
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
public class BinaryAtom extends Atom {
  private byte[] m_value;

/**
 * Tworzy nowy atom zawierajacy dane binarne.
 * @param name nazwa atomu.
 * @param val wartosc atomu.
 * @return nowy atom o podanej nazwie i wartosci.
 */
  public BinaryAtom(String name, byte[] val) {
    super(name);
  }

/**
 * Zwraca wartosc atomu.
 * @return wartosc atomu.
 */
  public byte[] getValue() {
    return m_value;
  }

/**
 * Ustala wartosc atomu.
 * @param newVal nowa wartosc atomu.
 */
  public void setValue(byte[] newVal) {
    m_value = newVal;
    setModified(true);
  }
}
