package pl.edu.pjwstk.yaod.atoms;

/**
 * Klasa reprezentujaca atom zawierajacy wartosc typu double.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class DoubleAtom extends Atom {
  private double m_value;

/**
 * Tworzy nowy atom zawierajacy wartosc typu double.
 * @param name nazwa atomu.
 * @param val wartosc atomu.
 * @return nowy atom o podanej nazwie i wartosci.
 */
  public DoubleAtom(String name, double val) {
    super(name);
    m_value = val;
  }

/**
 * Zwraca wartosc atomu.
 * @return wartosc atomu.
 */
  public double getValue() {
    return m_value;
  }

/**
 * Ustala wartosc atomu.
 * @param newVal nowa wartosc atomu.
 */
  public void setValue(double newVal) {
    m_value = newVal;
    setModified(true);
  }
}
