package pl.edu.pjwstk.yaod.atoms;

/**
 * Klasa reprezentujaca atom zawierajacy wartosc typu integer.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class IntegerAtom extends Atom {
  private int m_value;

/**
 * Tworzy nowy atom.
 * @param name nazwa atomu.
 * @param val wartosc atomu.
 * @return nowy atom.
 */
  public IntegerAtom(String name, int val) {
    super(name);
    m_value = val;
  }

/**
 * Zwraca wartosc atomu.
 * @return wartosc atomu.
 */
  public int getValue() {
    return m_value;
  }

/**
 * Istala nowa wartosc atomu.
 * @param newVal nowa wartosc atomu.
 */
  public void setValue(int newVal) {
    m_value = newVal;
    setModified(true);
  }
}
