package pl.edu.pjwstk.yaod.atoms;

import java.lang.reflect.*;

import pl.edu.pjwstk.yaod.atoms.*;

/**
 * Klasa reprezentujaca atom skladu obiektow javy. Pozwala na podpiecie
 * do tego skladu dowolnego obiektu String Javy.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class JavaStringAtom extends StringAtom {
  private Object m_JavaObject;
  private String m_JavaAttribute;
  private Field m_JavaField;

/**
 * Tworzy nowy atom.
 * @param name nazwa atomu.
 * @param obj obiekt zawierajacy atrybut majacy byc wartoscia atomu.
 * @param attr nazwa atrybutu obiektu obj, ktorego wartosc ma byc wartoscia atomu.
 * @exception NoSuchFieldException nazwa atrybutu nie istnieje w podanym obiekcie.
 * @return nowy atom.
 */
  public JavaStringAtom(String name, Object obj, String attr) throws NoSuchFieldException {
    super(name, "");

    m_JavaObject = obj;
    m_JavaAttribute = attr;
    m_JavaField = m_JavaObject.getClass().getField(attr);

    if (m_JavaField.getType() != String.class) 
      throw new NoSuchFieldException();
  }

/**
 * Ustala wartosc atomu (obiektu Javy).
 * @param val nowa wartosc atomu.
 */
  public void setValue(String val) {
    try {
      m_JavaField.set(m_JavaObject, val);
    }
    catch (IllegalAccessException e) {
      System.out.println("access");
    }
  }

/**
 * Zwraca wartosc atomu.
 * @return wartosc atomu.
 */
  public String getValue() {
    String res = null;
    try {
      res = (String) m_JavaField.get(m_JavaObject);
    }
    catch (IllegalAccessException e) {
      System.out.println("access");
    }
    return res;
  }  
}
