package pl.edu.pjwstk.yaod.atoms;

/**
 * Klasa reprezentujaca atom referencji. Zadaniem
 * referencji jest wskazywanie na inny atom. Refrencje
 * lacza sie z atomami zwrotnymi. Usuniecie wskazywanego
 * atomu laczy sie z automatycznym usunieciem referencji.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
 
public class ReferenceAtom extends Atom {
  private AtomID m_value;

/**
 * Tworzy nowy obiekt referencji.
 * @param name 
 * @exception XxxxxxException if ...
 * @return comments
 */
  public ReferenceAtom(String name, AtomID value) {
    super(name);
    m_value = value;
  }

/**
 * Zwraca wartosc referencji.
 * @return identyfikator atomu wskazywanego przez referencje.
 */
  public AtomID getValue() {
    return m_value;
  }

/**
 * Ustala wartosc referencji.
 * @param ptr identyfikator atomu wskazywanego przez referencje.
 */
  public void setValue(AtomID ptr) {
    m_value = ptr;
    setModified(true);
  }
}
