package pl.edu.pjwstk.yaod.atoms;

import java.util.*;

/**
 * Atom zlozony typu Ring. Posiada identyfikator pierwszego i ostatniego atomu
 * podrzednego, tworzac razem ze wszystkimi atomami cykliczna
 * liste dwukierunkowa.
 * TODO: klasa nie jest ukonczona i nie dziala.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
public class RingAtom extends Atom {
  private AtomID m_firstMember;
  private AtomID m_lastMember;

/**
 * Tworzy nowy obiekt typu ring.
 * @param name nazwa nowego atomu.
 * @return nowy ring.
 */
  public RingAtom(String name) {
    super(name);
  }  

/**
 * Ustala identyfikator pierwszego atomu podrzednego.
 * @param ptr identyfikator atomu, ktory ma byc pierwszym atomem podrzednym.
 */
  public void setFirstMember(AtomID ptr) {
    m_firstMember = ptr;
    setModified(true);
  }

/**
 * Zwraca identyfikator pierwszego atomu podrzednego.
 * @return identyfikator atomu podrzednego.
 */
  public AtomID getFirstMember() {
    return m_firstMember;
  }

/**
 * Ustala ostatni atom.
 * @param ptr identyfikator atomu, ktory ma byc ostatnim atomem podrzednym.
 */
  public void setLastMember(AtomID ptr) {
    m_lastMember = ptr;
    setModified(true);
  }

/**
 * Zwraca identyfikator ostatniego atomu podrzednego.
 * @return identyfikator aostatniego atomu.
 */
  public AtomID getLastMember() {
    return m_lastMember;
  }
}
