package pl.edu.pjwstk.yaod.atoms;

/**
 * Klasa reprezentujaca atom zawierajacy wartosc typu string.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class StringAtom extends Atom {
  private String m_value;

/**
 * Tworzy nowy atom zawierajacy wartosc string.
 * @param name nazwa atomu.
 * @param val wartosc atomu.
 * @return nowy atom.
 */

  public StringAtom(String name, String val) {
    super(name);
    m_value = val;
  }

/**
 * Zwraca wartosc atomu.
 * @return wartosc atomu.
 */
  public String getValue() {
    return m_value;
  }

/**
 * Ustala wartosc atomu.
 * @param newVal nowa wartosc atomu.
 */
  public void setValue(String newVal) {
    m_value = newVal;
    setModified(true);
  }
}
