package pl.edu.pjwstk.yaod.creators;

import pl.edu.pjwstk.yaod.store.*;
import pl.edu.pjwstk.yaod.store.defaultstore.persistentstore.*;
import pl.edu.pjwstk.yaod.system.*;
import pl.edu.pjwstk.yaod.util.*;

/**
 * Klasa jest prostym kreatorem bazy danych. Tworzy baze danych
 * zawierajaca sklad trwalych obiektow i dwa pliki danych.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class DatabaseCreator {
  private Database db;
  private DatabaseManager dbi;

  public void begin(String dest) throws Exception {
    PersistentStoreDescriptor desc =
      new PersistentStoreDescriptor("pers0", "pl.edu.pjwstk.yaod.store.defaultstore.persistentstore.PersistentStore");

    desc.setBlockSize((short) 8192);
    desc.registerDatafile(new DatafileDescriptor((short) 0, dest + "test1.dbf", 10000000, (short) 8192));
    desc.registerDatafile(new DatafileDescriptor((short) 1, dest + "test2.dbf", 20000000, (short) 8192));

    new ObjectSerializer().writeObject(desc, dest + "pers1.ctl");

    db = new Database();
    db.registerStore(dest + "pers1.ctl");

    DatabaseManager dbi = new DatabaseManager(db);
    dbi.start();
    dbi.initialize();
    dbi.stop();

    new ObjectSerializer().writeObject(db, dest + "db.ctl");

    System.out.println("Database created");
  }

  public final static void main(String[] args) throws Exception {
    if (args.length == 2 && args[0].equals("-dest")) {
      DatabaseCreator creator = new DatabaseCreator();
      creator.begin(args[1]); 
    }
    else 
      System.out.println("Parameters:\n -dest path - a directory where database files should be created");
  }
}
