package pl.edu.pjwstk.yaod.debug.blocks;

import java.io.*;

import pl.edu.pjwstk.yaod.store.*;
import pl.edu.pjwstk.yaod.store.defaultstore.blocks.*;
import pl.edu.pjwstk.yaod.store.defaultstore.persistentstore.*;

/**
 * Klasa ma charakter testowy i sluzy do debugowania funkcjonowania
 * blokow bazy danych offline (bez uruchamiania serwera).
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class BlockTester  {
  public BlockTester() {
  }

  public void begin() throws Exception {
    BlockTesterStore store = new BlockTesterStore();
    PersistentRecordManager recman = new PersistentRecordManager(store);

    PersistentRecordID recID1 = recman.createRecord("napis".getBytes());
    PersistentRecordID recID2 = recman.createRecord("dodatek".getBytes());

    recman.updateRecord(recID1, "zmieniony napis".getBytes());
    recman.updateRecord(recID2, "dodatek inny".getBytes());

    recman.deleteRecord(recID1);

    PersistentRecordID recID3 = recman.createRecord("jeszcze jeden napis".getBytes());
  }

  public static void main(String[] args) throws Exception {
    BlockTester blocksDebug = new BlockTester();
    blocksDebug.begin();
  }
}