package pl.edu.pjwstk.yaod.debug.blocks;

import java.io.*;

import pl.edu.pjwstk.yaod.store.*;
import pl.edu.pjwstk.yaod.store.defaultstore.blocks.*;
import pl.edu.pjwstk.yaod.store.defaultstore.persistentstore.*;

/**
 * Klasa ma charakter testowy. Jej zadaniem pomoc przy debugowaniu
 * blokow. Uzupelnia BlockTester o namiastke skladu danych
 * (skladem jest tutaj tablica Javy).
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class BlockTesterStore extends PersistentBlockManager {
  AbstractBlock[] store = new AbstractBlock[25];

  public BlockTesterStore() throws Exception {
    super(null);

    store[0] = new FreeSpaceBlock((short) 8192, new PersistentBlockID((short) 0, (short) 0, (short) 0));
    for (int i = 1; i < 25; i++) {
      store[i] = new DataBlock((short) 8192, new PersistentBlockID((short) 0, (short) 0, (short) i));
    }
  }

  public void writeBlock(AbstractBlock block) throws IOException {
  }

  public void updateFreeSpace(DataBlock block) throws Exception {
  }

  public FreeSpaceBlock readFreeSpaceBlock(AbstractBlockID ptr) throws IOException, BlockFormatException {
    return (FreeSpaceBlock) store[0];
  }

  public DataBlock readDataBlock(AbstractBlockID ptr) throws IOException, BlockFormatException {
    return (DataBlock) store[((PersistentBlockID) ptr).getBlockID()];
  }

  public DataBlock findDataBlockByFreeSpace(int reqSpace) throws Exception {
    for (int i = 1; i < 25; i++) {
      DataBlock block = (DataBlock) store[i];
      if (block.getFreeSpaceSize() >= reqSpace)
        return block;
    }
    throw new Exception("No free space");
  }

  public short getBlockSize() {
    return 8192;
  }
}
