package pl.edu.pjwstk.yaod.network;

import java.io.*;

import java.net.*;

import java.util.*;

import pl.edu.pjwstk.yaod.system.processes.*;
import pl.edu.pjwstk.yaod.yaql.*;
import pl.edu.pjwstk.yaod.network.protocol.queryresult.*;

/**
 * Klasa zapewnia mozliwosc komunikacji miedzy klientem i serwerem
 * za pomoca protokolu HTTP.
 * TODO: skonczyc
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
 
public class HTTPCommunicator implements Communicable {
  private SVRP m_server;
  private Socket m_socket;
  private BufferedReader m_input;
  private BufferedWriter m_output;

  public HTTPCommunicator(Socket socket, SVRP server) throws IOException {
    m_socket = socket;
    m_server = server;
    m_output = new BufferedWriter(new OutputStreamWriter(m_socket.getOutputStream()));
    m_input = new BufferedReader(new InputStreamReader(m_socket.getInputStream()));
  }

  public void serveRequest() throws IOException {
    String inputLine = m_input.readLine();

    if (inputLine.startsWith("GET ") == false)
      return;

    String command = null, url = null, procedure = null, parameters = null;
    try {
      StringTokenizer tokenizer = new StringTokenizer(inputLine);
      command = tokenizer.nextToken();
      url = tokenizer.nextToken();
      procedure = url.substring(url.indexOf("/") + 1);
      procedure = url.substring(url.indexOf("/") + 1, url.indexOf("?"));
      parameters = url.substring(url.indexOf("?") + 1);
    }
    catch (Exception e) {}
  
    try {
      Vector resvec = m_server.execute(m_server.getInterpreter(), procedure + "();");
      Result res = (Result) resvec.firstElement();
      okMessage("<?xml version=\"1.0\"?>\n<result>" + res.getResultAsXmlString() + "</result>\n");
    }
    catch (SBQLException e) {
      String message = e.getMessage();
      
      message.replace('<', '[');
      message.replace('>', ']');
      
      okMessage("<?xml version=\"1.0\"?>\n <error>\n " + message.toString() + "</error>\n");
    }
    
    m_socket.close();
  }

  private void okMessage(String msg) throws IOException {
    String out =  "HTTP/1.1 200 OK\n" + 
                  "Server: Yaod 1.0\n" +
                  "Content-Type: text/xml\n\n" +
                  msg;

    m_output.write(out);
    m_output.flush();
  }

  private void badRequestMessage() throws IOException {
    String out =  "HTTP/1.1 400 Bad Request\n" + 
                  "Server: Yaod 1.0\n";
                  
    m_output.write(out);
  }
}
