package pl.edu.pjwstk.yaod.network.protocol;

/**
 * Klasa realizujaca zadanie zaladowania do bazy danych przeslanego dokumentu XML.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class XMLLoadRequest extends ClientRequest {
  private String m_xmldoc;

/**
 * Tworzy nowe zadanie.
 * @param xmldoc dokument XML.
 * @return obiekt nowego zadania.
 */
  public XMLLoadRequest(String xmldoc) {
    m_xmldoc = xmldoc;
  }

/**
 * Zwraca dokument XML przypisany temu zadaniu.
 * @return dokument XML.
 */
  public String getDocument() {
    return m_xmldoc;
  }
}
