package pl.edu.pjwstk.yaod.network.protocol.queryresult;
import pl.edu.pjwstk.yaod.network.protocol.queryresult.SingleResult;

public class BinderResult extends SingleResult {
  private String name;
  private Result value; 
  
  public BinderResult(String name, Result value) {
    this.name  = name;
    this.value = value;
  }
  public String getName() { 
  	return name;
  }
  public void setName(String name) { 
  	this.name = name;
  }
  public Result getValue() {
    return value;
  }
  public String getValueAsString() {
    if (value instanceof AtomicResult) {
      return ((AtomicResult)value).getValueAsString();
    } else
      return "BINDER";
  }

  protected String getResultAsString(String st) {
    if (value instanceof AtomicResult ) {
      String tmp = (value instanceof StringResult) ? "\"" : "";
      return st + getName() + "( " + 
             tmp + ((AtomicResult)value).getValueAsString() + tmp +
             " )\n";
    } else if (value instanceof IdentifierResult) {
      return st + getName() + "( " + 
             ((IdentifierResult)value).getValueAsString() +
             " )\n";
    } else {
      return st + getName() + "(\n" +
             value.getResultAsString(st + "  ") +
             st + ")\n";
    }
	}
  protected String getResultAsXmlString(String st) {
    if (this.getName().equals("TEXT")) {
      if (value instanceof StringResult) {
        return st + ((AtomicResult)value).getValueAsString() + "\n";
      }
    }

    if (value instanceof AtomicResult) {
      return st + "<" + getName() + ">" + 
             ((AtomicResult)value).getValueAsString() +
             "</" + getName() + ">\n";
    } else if (value instanceof IdentifierResult) {
      return st + "<" + getName() + ">" + 
             ((IdentifierResult)value).getValueAsString() +
             "</" + getName() + ">\n";
    } else if (value instanceof BinderResult) {
      if (((BinderResult)value).getName().equals("ATTRIBUTES") == true) {
        String tmp_res = getATTRIBUTES((BinderResult) value);
        return st + "<" + getName() + tmp_res + "/>";
      } else 
        return st + "<" + getName() + ">\n" + 
               value.getResultAsXmlString(st + "  ") +
               st + "</" + getName() + ">\n";
    } else if (value instanceof ComplexResult) {
      if (existATTRIBUTES((ComplexResult)value) == true) {
        int i = indexOfATTRIBUTES((ComplexResult)value);
        String tmp_res = getATTRIBUTES((BinderResult)((ComplexResult)value).getResultAt(i));
        if (((ComplexResult)value).getSize() == 1)
          return st + "<" + getName() + tmp_res + "/>\n";
        else
          return st + "<" + getName() + tmp_res + ">\n" + 
                 value.getResultAsXmlString(st + "  ") +
                 st + "</" + getName() + ">\n";
      } else
        return st + "<" + getName() + ">\n" + 
               value.getResultAsXmlString(st + "  ") +
               st + "</" + getName() + ">\n";
    } else
      return st + "<" + getName() + ">\n" + 
             value.getResultAsXmlString(st + "  ") +
             st + "</" + getName() + ">\n";
	}

  public String getATTRIBUTES(BinderResult br) {
    String tmp_res = "";
    if (br.getValue() instanceof ComplexResult) {          
      for (int i=0; i<((ComplexResult)br.getValue()).getSize(); i++) {
        if (((ComplexResult)br.getValue()).getResultAt(i) instanceof BinderResult) {
          BinderResult tmp = (BinderResult)((ComplexResult)br.getValue()).getResultAt(i);
          tmp_res += " " + tmp.getName() + "=\"" + tmp.getValueAsString() + "\"";
        }
      }
    } else {
      tmp_res = " " + br.getName() + "=\"" + br.getValueAsString() + "\"";
    }
    return tmp_res;
  }
  public boolean existATTRIBUTES(ComplexResult cv) {
    for (int i=0; i<cv.getSize(); i++) {
      if (cv.getResultAt(i) instanceof BinderResult) {
        BinderResult tmp = (BinderResult)cv.getResultAt(i);
        if (tmp.getName().equals("ATTRIBUTES")) {
          return true;
        }
      }
    }
    return false;
  }
  public int indexOfATTRIBUTES(ComplexResult cv) {
    for (int i=0; i<cv.getSize(); i++) {
      if (cv.getResultAt(i) instanceof BinderResult) {
        BinderResult tmp = (BinderResult)cv.getResultAt(i);
        if (tmp.getName().equals("ATTRIBUTES")) {
          return i;
        }
      }
    }
    return 0;    
  }
}