package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.*;

/**
 * Klasa rozszerzajaca mozliwosci statycznych struktur, jakimi sa
 * atomy typu double.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class YDouble extends YSimpleObject {
/**
 * Tworzy nowy obiekt zawierajacy wartosc double.
 * @param sp proces uslugowy.
 * @param name nazwa obiektu.
 * @param value wartosc obiektu.
 * @return nowy obiekt.
 */
  public YDouble(SVRP sp, String name, double value) {
    super(sp, new DoubleAtom(name, value));
  }

/**
 * @param sp proces uslugowy wykonujacy operacje dla danego obiektu.
 * @param atm istniejacy w skladzie atom.
 * @return nowy obiekt typu double.
 */
  public YDouble(SVRP sp, DoubleAtom atm) {
    super(sp, atm);
  }

/**
 * Zwraca wartosc obiektu.
 * @return wartosc obiektu.
 */
  public double getValue() {
    return ((DoubleAtom) getAtom()).getValue();
  }

/**
 * Ustala wartosc obiektu.
 * @param val nowa wartosc.
 */
  public void setValue(double val) {
    ((DoubleAtom) getAtom()).setValue(val);
  }

/**
 * Konwertuje double na string.
 * @return wartosc jako string.
 */
  public String stringValue() {
    return String.valueOf(getValue());
  }
}
