package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.*;

/**
 * Klasa rozszerzajaca statyczne struktury, jakimi sa atomy typu integer.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class YInteger extends YSimpleObject {

/**
 * Konstruktor tworzacy nowy obiekt YInteger. 
 * @param sp proces uslugowy, zapewniajacy obiektowi komunikacje z systemem.
 * @param name nazwa tworzonego obiektu.
 * @param value wartosc tworzonego obiektu.
 * @return nowy obiekt typu integer.
 */

  public YInteger(SVRP sp, String name, int value) {
    super(sp, new IntegerAtom(name, value));
  }

/**
 * Konstruktor tworzacy nowy obiekt YInteger na podstawie istniejacego
 * juz w systemie atomu.
 * @param sp proces uslugowy, zapewniajacy systemowi komunikacje z systemem.
 * @param atm atom, dla ktorego ma zostac utworzony obiekt YInteger.
 * @return nowy obiekt typu integer.
 */

  public YInteger(SVRP sp, IntegerAtom atm) {
    super(sp, atm);
  }

/**
 * Zwraca wartosc obiektu.
 * @return wartosc int obiektu YInteger.
 */

  public int getValue() {
    return ((IntegerAtom) getAtom()).getValue();
  }

/**
 * Ustala wartosc obiektu.
 * @param val nowa wartosc obiektu.
 */

  public void setValue(int val) {
    ((IntegerAtom) getAtom()).setValue(val);
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */

  public String stringValue() {
    return String.valueOf(getValue());
  }
}
