package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.*;

/**
 * Klasa obiektow typu double zapisanych w skladzie obiektow Javy.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class YJavaDouble extends YDouble {
/**
 * Tworzy obiekt typu double.
 * @param sp proces uslugowy majacy wykonywac operacje danego obiektu.
 * @param name nazwa tworzonego obiektu.
 * @param obj dowolny obiekt Javy zawierajacy podobiekt podpinany do skladu.
 * @return nowy obiekt typu double.
 */
  public YJavaDouble(SVRP sp, String name, Object obj, String attr) throws NoSuchFieldException {
    super(sp, new JavaDoubleAtom(name, obj, attr));
  }

/**
 * Tworzy obiekt na bazie atomu juz umieszczonego w bazie.
 * @param sp proces uslugowy majacy wykonywac operacje danego obiektu.
 * @param atm istniejacy atom.
 * @return nowy obiekt typu double.
 */
  public YJavaDouble(SVRP sp, JavaDoubleAtom atm) {
    super(sp, atm);
  }
}
