package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.SVRP;

/**
 * Klasa obiektow typu integer zapisanych w skladzie obiektow Javy.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */


public class YJavaInteger extends YInteger {
/**
 * Tworzy obiekt typu integer.
 * @param sp proces uslugowy majacy wykonywac operacje danego obiektu.
 * @param name nazwa tworzonego obiektu.
 * @param obj dowolny obiekt Javy zawierajacy podobiekt podpinany do skladu.
 * @return nowy obiekt typu integer.
 */
  public YJavaInteger(SVRP sp, String name, Object obj, String attr) throws NoSuchFieldException {
    super(sp, new JavaIntegerAtom(name, obj, attr));
  }

/**
 * Tworzy obiekt na bazie atomu juz umieszczonego w bazie.
 * @param sp proces uslugowy majacy wykonywac operacje danego obiektu.
 * @param atm istniejacy atom.
 * @return nowy obiekt typu integer.
 */
  public YJavaInteger(SVRP sp, JavaIntegerAtom atm) {
    super(sp, atm);
  }
}
