package pl.edu.pjwstk.yaod.objects;

import java.util.*;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.store.*;
import pl.edu.pjwstk.yaod.store.defaultstore.blocks.*;
import pl.edu.pjwstk.yaod.system.processes.*;
import pl.edu.pjwstk.yaod.util.*;

/**
 * Klasa reprezentujaca obiekty zlozone typu Ring.
 * TODO: skonczyc (nie dziala)
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class YRing extends YComplexObject {

  YRing(SVRP sp, String name) {
    super(sp, new RingAtom(name));
  }


  YRing(SVRP sp, RingAtom ring) {
    super(sp, ring);
  }

  void registerMember(ObjectID ptr) {
    System.out.println("zaimplementuj");
  }

  void unregisterMember(ObjectID ptr) {
    System.out.println("zaimplementuj");
  }


  public void setFirstMember(ObjectID member) {
    ((RingAtom) getAtom()).setFirstMember((AtomID) member);
  }


  public ObjectID getFirstMember() {
    return (ObjectID) ((RingAtom)getAtom()).getFirstMember();
  }


  public void setLastMember(ObjectID member) {
    ((RingAtom) getAtom()).setLastMember((AtomID) member);
  }


  public ObjectID getLastMember() {
    return (ObjectID) ((RingAtom)getAtom()).getLastMember();
  }


  public ObjectID getPreviousMember(ObjectID basePtr) {
    Wrappable store = getServer().getStoreByID(getOID().getStoreID());
    ObjectID prevPtr = null, currPtr;

    for (Enumeration e = getMembers(); e.hasMoreElements(); ) {
      currPtr = (ObjectID) e.nextElement();
      if (currPtr.equals(basePtr))
        return prevPtr;
      else
        prevPtr = currPtr;
    }
    return null;
  }

  public ObjectID getNextMember(ObjectID basePtr) {
    try {
      Wrappable store = getServer().getStoreByID(getOID().getStoreID());
      Atom baseAtm = store.retrieveAtom((AtomID) (AtomID) basePtr);
      return (ObjectID) baseAtm.getNext();
    }
    catch (NoSuchAtomException e) {
      Errors.printError(1, "Nonexistent next member atom (getNextMember()).");
    }
    return null;
  }


  public void connectMember(YObject member) throws BlockFreeSpaceException {
    Wrappable store = getServer().getStoreByID(getOID().getStoreID());

    Atom memberAtm = member.getAtom();
    store.createAtom(memberAtm);

    try {
      if (getLastMember() != null) {
        Atom lastMemberAtm = store.retrieveAtom((AtomID) (AtomID) getLastMember());
        lastMemberAtm.setNext(memberAtm.getAID());

        setLastMember((ObjectID) memberAtm.getAID());
      }
      if (getFirstMember() == null)
        setFirstMember((ObjectID) memberAtm.getAID());
      if (getLastMember() == null)
        setLastMember((ObjectID) memberAtm.getAID());
    }
    catch (NoSuchAtomException e) {
      e.printStackTrace();
    }
  }


  public void connectMemberAfter(YObject member, ObjectID base) throws BlockFreeSpaceException {
    
  }


  public void connectMemberBefore(YObject member, ObjectID base) throws BlockFreeSpaceException {
  
  }


  public void disconnectMember(ObjectID delPtr) {
/*    Storable store = getServer().getStoreByID(getOID().getStoreID());
  
    ObjectID prevPtr = getPreviousMember(delPtr);
    ObjectID nextPtr = getNextMember(delPtr);
    if (prevPtr == null) {

    }
    else
    if (nextPtr == null) {
      Atom prevAtm = store.retrieveAtom((AtomID) prevPtr);
      prevAtm.setNext(null);
      setLastMember(prevPtr);
    }
    else {
      Atom prevAtm = store.retrieveAtom((AtomID) prevPtr);
      prevAtm.setNext(nextPtr);
    }*/
  }


  public int countMembers() {
    int cnt = 0;
    for (Enumeration e = getMembers(); e.hasMoreElements(); ) {
      e.nextElement();
      cnt++;
    }
    return cnt;
  }


  public ObjectID getMemberAt(int index) {
    ObjectID memberPtr = null;
    int cnt = 0;
    for (Enumeration e = getMembers(); e.hasMoreElements() && cnt <= index; ) {
      memberPtr = (ObjectID) e.nextElement();
      if (cnt == index)
        return memberPtr;
      cnt++;
    }
    return memberPtr;
  }


  public ObjectID findMemberByName(String name, ObjectID startPtr) {
    return findMemberByNameAndType(name, Atom.ALL_TYPES, startPtr);
  }


  public ObjectID findMemberByType(byte type, ObjectID startPtr) {
    return null;
  }


  public ObjectID findMemberByNameAndType(String name, byte type, ObjectID currPtr) {
    Wrappable store = getServer().getStoreByID(getOID().getStoreID());

    try {
      if (currPtr == null)
        currPtr = getFirstMember();

      Atom currAtm = store.retrieveAtom((AtomID) currPtr);
      currAtm = store.retrieveAtom((AtomID) currPtr);
      currPtr = (ObjectID) currAtm.getNext();
    
      while (currPtr != null) {
        currAtm = store.retrieveAtom((AtomID) currPtr);
         if (currAtm.getName().equals(name) && (currAtm.getType() == type || type == Atom.ALL_TYPES))
            return currPtr;
        currPtr = (ObjectID) currAtm.getNext();
      }
    }
    catch (NoSuchAtomException e) {}

    return null;
  }



  public Enumeration getSubordinates() {
    return null;
  }


  public Enumeration getMembers() {
    return new Enumeration() {
      Wrappable store = getServer().getStoreByID(getOID().getStoreID());
      Atom currAtom;

      public boolean hasMoreElements() {
        return  (currAtom == null && getFirstMember() != null) ||
                (currAtom != null && currAtom.getNext() != null);
      }

      public Object nextElement() {
        try {
          if (currAtom == null && getFirstMember() != null) {
            currAtom = store.retrieveAtom((AtomID) getFirstMember());
            return getFirstMember();
          }
          if (currAtom != null && currAtom.getNext() != null) {
            currAtom = store.retrieveAtom((AtomID) currAtom.getNext());
            return currAtom.getAID();
          }
        }
        catch (NoSuchAtomException e) {
          Errors.printError(1, "AAAAAAAA!!!");
        }
        throw new NoSuchElementException();
      }
    };
  }
}
