package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.*;

/**
 * Klasa abstrakcyjna, majaca na celu zgrupowanie wszystkich obiektow
 * prostych. Obiekt prosty to taki, ktory nie jest zawiera referencji
 * do innych obiektow (nie jest obiektem referencyjnym ani zlozonym).
 * Przyklady obiektow prostych: string, integer, double.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
 
 
public abstract class YSimpleObject extends YObject {
/**
 * Konstruktor tworzacy nowy obiekt prosty.
 * @param sp proces uslugowy wykorzystywany do interakcji z systemem.
 * @param atom atom przyporzadkowany dla danego obiektu (np. YString ma atom StringAtom).
 * @return nowy obiekt prosty.
 */

  public YSimpleObject(SVRP sp, Atom atom) {
    super(sp, atom);
  }

/**
 * Konwertuje wartosc obiektu na string.
 * @return wartosc obiektu jako string.
 */
  public abstract String stringValue();
}
