package pl.edu.pjwstk.yaod.objects;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.processes.*;

/**
 * Klasa rozszerzajaca statyczne struktury, jakimi sa atomy typu string.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class YString extends YSimpleObject {

/**
 * Konstruktor tworzacy nowy obiekt typu string.
 * @param sp proces uslugowy, zapewniajacy obiektowi dostep do bazy danych.
 * @param name nazwa tworzonego obiektu.
 * @param value warto tworzonego obiektu.
 * @return nowy obiekt YString.
 */
  public YString(SVRP sp, String name, String value) {
    super(sp, new StringAtom(name, value));
  }

/**
 * Konstruktor tworzacy nowy obiekt typu string na podstawie
 * istniejacego juz w systemie atomu.
 * @param sp proces uslugowy, zapewniajacy obiektowi dostep do bazy danych.
 * @param value warto tworzonego obiektu.
 * @return nowy obiekt YString.
 */
  public YString(SVRP sp, StringAtom string) {
    super(sp, string);
  }

/**
 * Zwraca wartosc obiektu.
 * @return wartosc obiektu typu string.
 */
  public String getValue() {
    return ((StringAtom) getAtom()).getValue();
  }

/**
 * Ustanawia nowa wartosc obiektu.
 * @param val nowa wartosc.
 */
  public void setValue(String val) {
    ((StringAtom) getAtom()).setValue(val);
  }

/**
 * Konwertuje wartosc obiektu na string.
 * @return wartosc obiektu jako string.
 */
  public String stringValue() {
    return getValue();
  }
}
