package pl.edu.pjwstk.yaod.store;

import java.io.*;

import java.util.*;

import pl.edu.pjwstk.yaod.atoms.*;

/**
 * Obiekt zawierajacy dane konfiguracyjne dowolnego skladu.
 * Jego zserializowana wersja tworzy plik kontrolny skladu.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public abstract class AbstractStoreDescriptor implements Serializable {
  private String m_name;
  private String m_class;
  private AtomID m_entry;

/**
 * Tworzy nowy obiekt opisujacy konfiguracje skladu.
 * @param storeName nazwa skladu.
 * @param storeClass nazwa klasy implementujacej sklad (potrzebna
 * do dynamicznego ladowania skladow).
 * @return nowy deskryptor skladu.
 */
  public AbstractStoreDescriptor(String storeName, String storeClass) {
    m_name = storeName;
    m_class = storeClass;
  }

/**
 * Zwraca nazwe skladu.
 * @param paramName 
 * @exception XxxxxxException if ...
 * @return comments
 */
  public String getStoreName() {
    return m_name;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public String getStoreClassName() {
    return m_class;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public void setEntry(AtomID entry) {
    m_entry = entry;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public AtomID getEntry() {
    return m_entry;
  }
}
