package pl.edu.pjwstk.yaod.store.defaultstore.blocks;

import pl.edu.pjwstk.yaod.store.*;

/**
 * Klasa reprezentuje identyfikator bloku. Jest rozszerzana
 * przez identyfikatory blokow poszczegolnych skladow, poniewaz
 * stosuja one zupelnie inne techniki identyfikacji blokow.
 * Identyfikator bloku sklada sie zatem z numeru skladu
 * oraz identyfikatora charakterystycznego dla niego.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public abstract class BlockID extends AbstractBlockID {
/**
 * Tworzy nowy identyfikator bloku nalezacego do skladu o podanym
 * identyfikatorze.
 * @param store identyfikator skladu, do ktorego nalezy blok.
 * @return identyfikator bloku.
 */
  public BlockID(short store) {
    super(store);
  }

/**
 * Zwraca dlugosc identyfikatora bloku po jego zserializowaniu.
 * @return dlugosc identyfikatora bloku.
 */
  public abstract short sizeOf();

/**
 * Serializuje identyfikator bloku.
 * @return zserializowany identyfikator bloku.
 */
  public abstract byte[] toByteArray();
}
