package pl.edu.pjwstk.yaod.store.defaultstore.transientstore;

import pl.edu.pjwstk.yaod.atoms.*;

/**
 * 
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */
 
public class TransientAtomID extends TransientRecordID implements AtomID, java.io.Serializable {
  public TransientAtomID(short store, short block, short slot) {
    super(new TransientBlockID(store, block), slot);
  }

  public short getStoreID() {
    return getBlockID().getStoreID();
  }

  public int hashCode() {
    TransientBlockID blockID = (TransientBlockID) getBlockID();

    return  blockID.getStoreID() * 1000000 +
            blockID.getBlockID() * 100 +
            getSlotID();
  }

  public boolean equals(Object par) {
    if (par instanceof TransientAtomID == false)
      return false;

    TransientAtomID atomID2 = (TransientAtomID) par;
  
    TransientBlockID blockID1 = (TransientBlockID) ((TransientAtomID) par).getBlockID();
    TransientBlockID blockID2 = (TransientBlockID) getBlockID();
    
    return blockID1.getBlockID() == blockID2.getBlockID() && 
           blockID1.getStoreID() == blockID2.getStoreID() &&
           this.getSlotID() == atomID2.getSlotID();
  }

  public String toString() {
    TransientBlockID blockID = (TransientBlockID) getBlockID();

    return blockID.getStoreID() + "-" +
           blockID.getBlockID() + "-" + 
           getSlotID();
  }
}
