package pl.edu.pjwstk.yaod.store.defaultstore.transientstore;

import pl.edu.pjwstk.yaod.store.defaultstore.blocks.*;
import pl.edu.pjwstk.yaod.util.*;

public class TransientBlockID extends BlockID {
  private short m_block;
  private final static int RAW_STRUCT_LENGTH = NewBits.SHORT_SIZE;

  public TransientBlockID(short store, short block) {
    super(store);
    m_block = block;
  }

  public short getBlockID() {
    return m_block;
  }

  public int hashCode() {
    return getStoreID() * 10000 + m_block;
  }

  public byte[] toByteArray() {
    byte[] rawBlockID = new byte[RAW_STRUCT_LENGTH];
    NewBits.putShort(rawBlockID, 0, m_block);

    return rawBlockID;
  }

  public short sizeOf() {
    return RAW_STRUCT_LENGTH;
  }

  public boolean equals(Object par) {
    if (par instanceof TransientBlockID == false)
      return false;

    TransientBlockID cmp = (TransientBlockID) par;

    return cmp.getBlockID() == getBlockID() &&
           cmp.getStoreID() == getStoreID();
  }
}
