package pl.edu.pjwstk.yaod.store.javastore;

import java.io.*;

import java.util.*;

import pl.edu.pjwstk.yaod.atoms.*;
import pl.edu.pjwstk.yaod.system.*;
import pl.edu.pjwstk.yaod.store.*;
import pl.edu.pjwstk.yaod.system.DatabaseManager;

public class JavaStore extends AbstractStore {
  private AtomID m_entry;
  private Hashtable m_store = new Hashtable();

  public JavaStore(short id) {
    super(id);
  }

  public JavaStore(short id, JavaStoreDescriptor desc, DatabaseManager manager) {
    super(id);
  }

  public AbstractStoreDescriptor getStoreDescriptor() {
    return null;
  }

  public void setEntry(AtomID entry) {
    m_entry = entry;
  }

  public AtomID getEntry() {
    return m_entry;
  }

  public void open() throws FileNotFoundException {
  }

  public void close() throws IOException {
  }

  public void initialize() throws Exception {
    JavaStoreWrapper wrapper = (JavaStoreWrapper)createClient();

    SpiderAtom entry = new SpiderAtom("entry");
    wrapper.createAtom(entry);

    setEntry(entry.getAID());
  }

  public Wrappable createClient() {
    return new JavaStoreWrapper(this);
  }

  public void createAtom(Atom atm) {
    int i = 0;

    while (m_store.containsKey(new JavaAtomID(i)))
      i++;

    atm.setAID(new JavaAtomID(i));
    m_store.put(atm.getAID(), atm);
  }

  public Atom retrieveAtom(JavaAtomID id) {
    return (Atom) m_store.get(id);
  }

}
