package pl.edu.pjwstk.yaod.util;

import java.lang.reflect.*;

/**
 * Rozszerza Bits o kilka uzytecznych elementow majacych za zadanie
 * zasymulowac prace na wskaznikach, znany c.
 * 
 * @author M. Lentner, raist@ertel.com.pl
 * @version 1.0
 */

public class NewBits extends Bits {
  public final static byte BYTE_SIZE = 1;
  public final static byte SHORT_SIZE = 2;
  public final static byte INT_SIZE = 4;

/**
 * Zwraca wartosc short zapisana na 2 bajtach.
 * @param val wartosc do zakodowania.
 * @return tablica zawierajaca wartosc short.
 */
  public static byte[] getShort(short val) {
    byte[] ret = new byte[SHORT_SIZE];
    putShort(ret, 0, val);
    return ret;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public static byte[] getByte(byte val) {
    byte[] ret = new byte[1];
    ret[0] = val;
    return ret;
  }

/**
 * 
 * @exception XxxxxxException if ...
 * @return comments
 */
  public static byte[] concat(byte[] arr1, byte[] arr2) {
    if (arr2 == null) return arr1;
    return concat(arr1, arr2, arr2.length);
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public static byte[] concat(byte[] arr1, byte[] arr2, int arr2length) {
    if (arr2 == null || arr2length <= 0) return arr1;

    int arr1length = arr1 == null ? 0 : arr1.length;

    byte[] ret = new byte[arr1length + arr2length];
    if (arr1length > 0)
      System.arraycopy(arr1, 0, ret, 0, arr1length);
    if (arr2length > 0)
      System.arraycopy(arr2, 0, ret, arr1length, arr2length);

    return ret;
  }
}
