package pl.edu.pjwstk.yaod.workbench;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;

import pl.edu.pjwstk.yaod.workbench.details.*;
import pl.edu.pjwstk.yaod.workbench.dialogs.*;
import pl.edu.pjwstk.yaod.workbench.nodes.*;

public class MainWindow extends JFrame {
  ImageIcon test = new ImageIcon(MainWindow.class.getResource("/images/yaod_small.gif"));

  private JLabel statusBar = new JLabel();
  private JMenuItem menuFileExit = new JMenuItem();
  private JMenu menuFile = new JMenu();
  private JMenuBar menuBar = new JMenuBar();
  private JPanel panelCenter = new JPanel();
  private BorderLayout layoutMain = new BorderLayout();
  private BorderLayout borderLayout1 = new BorderLayout();

  private JSplitPane jSplitPane1 = new JSplitPane();

  private SystemTreePanel tree = new SystemTreePanel();
  private JMenu menuDebug = new JMenu();
  private JMenu jMenu2 = new JMenu();
  private JMenu jMenu3 = new JMenu();
  private JCheckBoxMenuItem jCheckBoxMenuItem1 = new JCheckBoxMenuItem();
  private JCheckBoxMenuItem jCheckBoxMenuItem2 = new JCheckBoxMenuItem();
  private JRadioButtonMenuItem jCheckBoxMenuItem3 = new JRadioButtonMenuItem();
  private JRadioButtonMenuItem jCheckBoxMenuItem4 = new JRadioButtonMenuItem();
  private JMenu jMenu1 = new JMenu();
  private JMenuItem jMenuItem1 = new JMenuItem();
  private ButtonGroup repGroup = new ButtonGroup();

  public MainWindow() {
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setIconImage(test.getImage());
  
    this.setJMenuBar(menuBar);
    this.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(borderLayout1);
    jSplitPane1.setDividerSize(3);

    tree.setMinimumSize(new Dimension(100, 24));
    tree.setPreferredSize(new Dimension(220, 324));
    menuDebug.setText("Debug");
    menuDebug.setBackground(SystemColor.control);
    jMenu3.setText("Query results");

    jCheckBoxMenuItem3.setText("Yaod representation");
    jCheckBoxMenuItem4.setText("XML representation");
    jCheckBoxMenuItem4.addItemListener(new ItemListener() {
        public void itemStateChanged(ItemEvent e) {
          jCheckBoxMenuItem4_itemStateChanged(e);
        }
      });

    jCheckBoxMenuItem3.setSelected(true);
    jCheckBoxMenuItem3.addItemListener(new ItemListener() {
        public void itemStateChanged(ItemEvent e) {
          jCheckBoxMenuItem3_itemStateChanged(e);
        }
      });

    repGroup.add(jCheckBoxMenuItem3);
    repGroup.add(jCheckBoxMenuItem4);
    jMenu1.setText("Help");
    jMenu1.setBackground(SystemColor.control);
    jMenuItem1.setText("About");
    jMenuItem1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItem1_actionPerformed(e);
        }
      });
    this.setSize(new Dimension(639, 499));
    this.setTitle("Yaod Workbench");

    this.setBackground(SystemColor.control);
    menuFile.setText("File");
    menuFile.setBackground(SystemColor.control);
    menuBar.setBackground(SystemColor.control);
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
          fileExit_ActionPerformed(ae);
        }
      });
    statusBar.setText("");

    menuFile.add(menuFileExit);
    menuBar.add(menuFile);
    jMenu3.add(jCheckBoxMenuItem3);
    jMenu3.add(jCheckBoxMenuItem4);
    menuDebug.add(jMenu3);
    menuBar.add(menuDebug);
    jMenu1.add(jMenuItem1);
    menuBar.add(jMenu1);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);

    tree.addSystemTreeNodeListener(new NodeSelectionListener() {
      public void nodeSelected(AbstractWorkbenchNode node) {
        if (node != null) {
          JPanel panel = node.getDetailsPanel();
          jSplitPane1.add(panel, JSplitPane.RIGHT);
        }
      }
    });

    jSplitPane1.add(tree, JSplitPane.LEFT);
    jSplitPane1.add(new SystemPanel(), JSplitPane.RIGHT);
    panelCenter.add(jSplitPane1, BorderLayout.CENTER);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
  }

  void fileExit_ActionPerformed(ActionEvent e) {
    System.exit(0);
  }

  private void jMenuItem1_actionPerformed(ActionEvent e) {
    AboutDialog dialog = new AboutDialog(this, "About Yaod Workbench", true);
    dialog.setLocationRelativeTo(jSplitPane1);
    dialog.show();
  }

  private void jCheckBoxMenuItem3_itemStateChanged(ItemEvent e) {
    if (e.getStateChange() == e.SELECTED) { 
      tree.getDBManagersNode().setShowResultSchema(DBManagersNode.YAOD_RESULTS); }
  }

  private void jCheckBoxMenuItem4_itemStateChanged(ItemEvent e) {
    if (e.getStateChange() == e.SELECTED)
      tree.getDBManagersNode().setShowResultSchema(DBManagersNode.XML_RESULTS);
  }
}
