package pl.edu.pjwstk.yaod.workbench.details;

import java.awt.*;
import java.awt.event.*;

import java.io.*;

import java.net.*;

import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import pl.edu.pjwstk.yaod.workbench.*;
import pl.edu.pjwstk.yaod.workbench.details.*;
import pl.edu.pjwstk.yaod.workbench.nodes.*;

public class SystemTreePanel extends JPanel  {
  private JTree jTree1 = new JTree();

  private SystemNode sysTreeRoot = new SystemNode(jTree1, new SystemPanel());
  private DefaultTreeModel sysTreeModel = new DefaultTreeModel(sysTreeRoot);

  private BorderLayout borderLayout1 = new BorderLayout();
  private JScrollPane jScrollPane1 = new JScrollPane();

  private Vector treeNodeListeners = new Vector();
  private Vector nodeActionListeners = new Vector();

  private DefaultMutableTreeNode lsNodes;
  private DefaultMutableTreeNode dbNodes;

  private JMenuItem dbmanConnectMenu, dbmanDisconnectMenu;

  private DBManagersNode m_dbmanagers;

  public SystemTreePanel() {
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  public JTree getTree() {
    return jTree1;
  }

  public void addSystemTreeNodeListener(NodeSelectionListener lsnr) {
    treeNodeListeners.add(lsnr);
  }

  public void addNodeActionListener(NodeActionListener lsnr) {
    nodeActionListeners.add(lsnr);
  }

  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    jTree1.setPreferredSize(new Dimension(180, 64));
    jTree1.setFont(new Font("Arial", 0, 11));
    jTree1.setModel(sysTreeModel);
    jScrollPane1.getViewport().add(jTree1, null);
    this.add(jScrollPane1, BorderLayout.CENTER);
    jTree1.setShowsRootHandles(true);
    jTree1.setCellRenderer(new NodeRenderer());

    jTree1.addTreeSelectionListener(new TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent ev) {
        AbstractWorkbenchNode node =
          (AbstractWorkbenchNode)jTree1.getLastSelectedPathComponent();

        for (Enumeration e = treeNodeListeners.elements(); e.hasMoreElements(); )
          ((NodeSelectionListener) e.nextElement()).nodeSelected(node);
      }
    });

    jTree1.addMouseListener(new SystemTreePanel.PopupListener());

//    AgentsNode agents = new AgentsNode();
    m_dbmanagers = new DBManagersNode();

//    sysTreeRoot.add(agents);
    sysTreeRoot.add(m_dbmanagers);
  }

  public DBManagersNode getDBManagersNode() {
    return m_dbmanagers;
  }

  class PopupListener extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
      maybeShowPopup(e);
    }

    private void maybeShowPopup(MouseEvent e) {
      if (e.isPopupTrigger()) {
        AbstractWorkbenchNode node =
          (AbstractWorkbenchNode)jTree1.getLastSelectedPathComponent();

        if (node != null) {
          JPopupMenu popupMenu = node.getPopupMenu();

          if (popupMenu != null)
            popupMenu.show(e.getComponent(), e.getX(), e.getY());
        }
      }
    }
  }
}
