package pl.edu.pjwstk.yaod.workbench.nodes;

import java.io.*;

import javax.swing.*;

import pl.edu.pjwstk.yaod.network.*;
import pl.edu.pjwstk.yaod.network.protocol.*;
import pl.edu.pjwstk.yaod.workbench.details.*;
import pl.edu.pjwstk.yaod.network.YNETCommunicator;

public class DBDumpNode extends AbstractWorkbenchNode {
  DBDumpPanel m_detailsPanel = new DBDumpPanel();

  ImageIcon atIcon = new ImageIcon(DBDumpNode.class.getResource("/images/atoms.gif"));

  public DBDumpNode() {
  }

  public String toString() {
    return "Atoms";
  }

  public Icon getIcon() {
    return atIcon;
  }

  public JPanel getDetailsPanel() {
    getDump();
    return m_detailsPanel;
  }

  private void getDump() {
    DBManagerNode dbmNode = (DBManagerNode) getParent();
    YNETCommunicator comm = (YNETCommunicator)dbmNode.getCommunicator();
    
    DumpRequest req = new DumpRequest();
    try {
      comm.putMessage(req);
      DumpReply rep = (DumpReply) comm.getMessage();
      m_detailsPanel.setDumpData(rep.getDump());
    }
    catch (IOException e) {
      e.printStackTrace();
    }
  }
}