package pl.edu.pjwstk.yaod.workbench.nodes;

import java.awt.event.*;

import java.io.*;

import javax.swing.*;
import javax.swing.tree.*;

import pl.edu.pjwstk.yaod.workbench.*;
import pl.edu.pjwstk.yaod.workbench.dialogs.*;

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */

public class DBManagersNode extends AbstractWorkbenchNode {
  public final static int YAOD_RESULTS = 1;
  public final static int XML_RESULTS = 2;
  private int m_resultsSchema = YAOD_RESULTS;

  private JMenuItem m_connectMenu = new JMenuItem("Register");

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public DBManagersNode() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public void jbInit() throws Exception {
    m_connectMenu.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RegisterDBDialog dialog = new RegisterDBDialog(null, "Registering a database ...", true);
        dialog.setLocationRelativeTo(getDetailsPanel());
        dialog.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            RegisterDBDialog dialog = (RegisterDBDialog) e.getSource();
            registerDB(null, dialog.getHost(), dialog.getPort());
          }
        });
        dialog.show();
      }
    });
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public Icon getIcon() {
    return pl.edu.pjwstk.yaod.workbench.NodeRenderer.CLOSED_ICON;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public JPanel getDetailsPanel() {
    return new JPanel();
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public String toString() {
    return "Databases";
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public JPopupMenu getPopupMenu() {
    JPopupMenu menu = new JPopupMenu();
    menu.add(m_connectMenu);

    return menu;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public void setShowResultSchema(int schema) {
    switch (schema) {
      case YAOD_RESULTS : m_resultsSchema = YAOD_RESULTS; break;
      case XML_RESULTS  : m_resultsSchema = XML_RESULTS; break;
    }
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public int getShowResultSchema() {
    return m_resultsSchema;
  }

/**
 * 
 * @param paramName comments
 * @exception XxxxxxException if ...
 * @return comments
 */
  public void registerDB(String name, String host, int port) {
    if (name == null)
      name = host + ":" + port;
    DBManagerNode dbmNode = new DBManagerNode(name, host, port);
    dbmNode.addNodeActionListener(new NodeActionListener() {
      public void dbConnectRequested(DBManagerNode node) {
        try {
          node.connect();
          getTree().repaint();
          ((DefaultTreeModel) getTree().getModel()).reload(node);
        }
        catch (IOException e) {
          JOptionPane.showMessageDialog(null, e.getMessage(), "Network error", JOptionPane.ERROR_MESSAGE);
        }
      }

      public void dbDisconnectRequested(DBManagerNode node) {
        node.disconnect();

        node.removeAllChildren();
        ((DefaultTreeModel) getTree().getModel()).reload(node);

        getTree().repaint();
      }
    });
    this.add(dbmNode);
    
    getTree().repaint();
    ((DefaultTreeModel) getTree().getModel()).reload(this);
  }
}
