package pl.edu.pjwstk.yaod.workbench.nodes;

import java.awt.event.*;

import java.io.*;

import javax.swing.*;

import pl.edu.pjwstk.yaod.xml.*;
import pl.edu.pjwstk.yaod.network.*;
import pl.edu.pjwstk.yaod.network.protocol.*;
import pl.edu.pjwstk.yaod.network.YNETCommunicator;

public class XMLDocumentsNode extends AbstractWorkbenchNode {
  private JMenuItem m_loadMenu = new JMenuItem("Load XML");

  public XMLDocumentsNode() {
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  public Icon getIcon() {
    return pl.edu.pjwstk.yaod.workbench.NodeRenderer.CLOSED_ICON;
  }

  public JPanel getDetailsPanel() {
    return super.getDetailsPanel();
  }

  public JPopupMenu getPopupMenu() {
    JPopupMenu menu = new JPopupMenu();
    menu.add(m_loadMenu);

    return menu;
  }

  public String toString() {
    return "XML Documents";
  }

  private void jbInit() throws Exception {
    m_loadMenu.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          m_loadMenu_actionPerformed(e);
        }
      });
  }

  private void m_loadMenu_actionPerformed(ActionEvent e) {
    JFileChooser fileChooser = new JFileChooser();
    fileChooser.showOpenDialog(getDetailsPanel());

    try {
      File file = fileChooser.getSelectedFile();
      if (file == null) return;
      
      FileReader fr = new FileReader(file);
      BufferedReader br = new BufferedReader(fr);

      StringBuffer buf = new StringBuffer();

      String line;
      while ( (line = br.readLine()) != null) {
        buf.append(line);
      }

      XMLLoadRequest xmlreq = new XMLLoadRequest(buf.toString());

      DBManagerNode dbmNode = (DBManagerNode) getParent();
      YNETCommunicator comm = (YNETCommunicator)dbmNode.getCommunicator();

      comm.putMessage(xmlreq);
      ServerReply reply = (ServerReply) comm.getMessage();
        
      JOptionPane.showMessageDialog(getDetailsPanel(),
        reply.getMessage(), "XML loader status", JOptionPane.INFORMATION_MESSAGE);

      br.close();
      fr.close();
    }
    catch (IOException ex) {
      System.out.println(ex.getMessage());
    }    
  }
}