package pl.edu.pjwstk.yaod.yaql;

/**
 * The <code>SBQLException</code> class represents an exception which is
 * thrown if an error occurs during program interpretation. It possess
 * the reason of the error in <code>message</code> value.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class SBQLException extends Exception {
  public String message;

/**
 * Creates a new exception with specified <code>message</code>.
 * @param message the message representing the error.
 */
  public SBQLException(String message) {
    this.message = message;
  }

/**
 * Returns the exception name.
 * @return the message representing the exception name.
 */
  public String getExceptionName() {
    return "SBQL ERROR";
  }

/**
 * Returns the exception message.
 * @return the message representing the reason of the exception.
 */
  public String getMessage() {
    return message;
  }

/**
 * Sets the exception message.
 * @param message the new message to be set.
 */
  public void setMessage(String message) {
    this.message = message;
  }
}