package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions;

import pl.edu.pjwstk.yaod.yaql.visitors.Visitor;
import pl.edu.pjwstk.yaod.yaql.visitors.EvalException;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.BinaryExpression;

/**
 * The <code>AlgebraicExpression</code> class represents the binary algebraic
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public abstract class AlgebraicExpression extends BinaryExpression  {

/**
 * Creates a new binary expression node with the given expressions <code>l</code>
 * and <code>r</code>.
 * @param l any expression.
 * @param r any expression.
 */
  public AlgebraicExpression(Expression l, Expression r) {
    super(l,r);
  }

/**
 * Method responsible for traversing the abstract syntax tree structure.
 * @see Visitor
 * @param v the visitor.
 * @exception EvalException if evaluation fails.
 */
  public void accept(Visitor v) throws EvalException {
    v.visit(this);
  }
}