package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;

/**
 * The <code>BinaryExpression</code> class represents the binary expression 
 * nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public abstract class BinaryExpression extends Expression {
  public Expression l, r;

/**
 * Creates a new binary expression node with the given expressions <code>l</code>
 * and <code>r</code>.
 * @param l any expression.
 * @param r any expression.
 */
  public BinaryExpression (Expression l, Expression r) {
    this.l  = l;
    this.r = r;
  }

/**
 * Method responsible for displaying the binary node.
 * @param st the string which is an auxiliary tabulator.
 */
  public void show(String st) {
    System.out.print(" [ " + getPreparedTypeAsString() + " ]\t");
    System.out.println(st + getSpellingAndPosition());
    l.show(st + "  ");
    r.show(st + "  ");
  }
}
