package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions;

import pl.edu.pjwstk.yaod.yaql.visitors.Visitor;
import pl.edu.pjwstk.yaod.yaql.visitors.EvalException;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.UnaryExpression;

/**
 * The <code>NonParametricExpression</code> class represents the unary 
 * non parametric expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public abstract class NonParametricExpression extends UnaryExpression {

/**
 * Creates a new unary non parametric expression node with the given expression 
 * <code>r</code>.
 * @param r any expression.
 */
  public NonParametricExpression (Expression r) {
    super(r);
  }


/**
 * Method responsible for traversing the abstract syntax tree structure.
 * @see Visitor
 * @param v the visitor.
 * @exception EvalException if evaluation fails.
 */
  public void accept(Visitor v) throws EvalException {
    v.visit(this);
  }
}
