package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions;

import pl.edu.pjwstk.yaod.yaql.visitors.Visitor;
import pl.edu.pjwstk.yaod.yaql.visitors.EvalException;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.IdentifierTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.UnaryExpression;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;

/**
 * The <code>ParametricExpression</code> class represents the unary 
 * parametric expression nodes in the
 * abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public abstract class ParametricExpression extends UnaryExpression  {
  public IdentifierTerminal i;

/**
 * Creates a new unary parametric expression node with the given expression
 * <code>l</code>.
 * @param l any expression.
 */
  public ParametricExpression(Expression l) {
    super(l);
  }


/**
 * Method responsible for traversing the abstract syntax tree structure.
 * @see Visitor
 * @param v the visitor.
 * @exception EvalException if evaluation fails.
 */
  public void accept(Visitor v) throws EvalException {
    v.visit(this);
  }
}