package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;

/**
 * The <code>UnaryExpression</code> class represents the unary expression nodes 
 * in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public abstract class UnaryExpression extends Expression {
  public Expression r;

/**
 * Creates a new unary expression node with the given expression <code>r</code>.
 * @param r any expression.
 */
  public UnaryExpression (Expression r) {
    this.r = r;
  }

/**
 * Method responsible for displaying the unary node.
 * @param st the string which is an auxiliary tabulator.
 */
  public void show(String st) {
    System.out.print(" [ " + getPreparedTypeAsString() + " ]\t");
    System.out.println(st + getSpellingAndPosition());
    r.show(st + "  ");
  }
}
