package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.single;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.OperatorTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.SingleExpression;

/**
 * The <code>AsteriskExpression</code> class represents the single 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class AsteriskExpression extends SingleExpression {
  public OperatorTerminal o;

/**
 * Creates a new single expression node with the given terminal <code>o</code>.
 * @param o operator terminal.
 */
  public AsteriskExpression (OperatorTerminal o) {
    this.o = o;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_ASTERISK";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (o.getSpelling() + " " + o.getPosition());
  }
}
