package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.single;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.LiteralTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.SingleExpression;

/**
 * The <code>BooleanExpression</code> class represents the single 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class BooleanExpression extends SingleExpression { 
  public LiteralTerminal lit;

/**
 * Creates a new single expression node with the given terminal <code>lit</code>.
 * @param lit literal terminal.
 */
  public BooleanExpression(LiteralTerminal lit) {
    this.lit = lit;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_LITERAL_BOOLEAN";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (lit.getSpelling() + " " + lit.getPosition());
  }
}