package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.single;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.KeywordTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.SingleExpression;

/**
 * The <code>EmptyBagExpression</code> class represents the single 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class EmptyBagExpression extends SingleExpression {
  KeywordTerminal k;

/**
 * Creates a new single expression node with the given terminal <code>k</code>.
 * @param k keyword terminal.
 */
  public EmptyBagExpression(KeywordTerminal k) {
    this.k = k;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_EMPTYBAG";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (k.getSpelling() + " " + k.getPosition());
  }
}