package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.single;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.IdentifierTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.SingleExpression;

/**
 * The <code>EmptyProcedureCallExpression</code> class represents the single 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class EmptyProcedureCallExpression extends SingleExpression {
  public IdentifierTerminal i;

/**
 * Creates a new single expression node with the given terminal <code>i</code>.
 * @param i identifier terminal.
 */
  public EmptyProcedureCallExpression(IdentifierTerminal i) {
    this.i = i;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_EMPTYPROCEDURECALL";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (i.getSpelling() + " " + i.getPosition());
  }
}