package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.single;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.IdentifierTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.SingleExpression;

/**
 * The <code>IdentifierExpression</code> class represents the single 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class IdentifierExpression extends SingleExpression {
  public IdentifierTerminal id;

/**
 * Creates a new single expression node with the given terminal <code>id</code>.
 * @param id identifier terminal.
 */
  public IdentifierExpression (IdentifierTerminal id) {
    this.id = id;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_IDENTIFIER";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (id.getSpelling() + " " + id.getPosition());
  }
}
