package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.unary;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.KeywordTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.NonParametricExpression;

/**
 * The <code>MaximumExpression</code> class represents the unary 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class MaximumExpression extends NonParametricExpression {
  KeywordTerminal k;

/**
 * Creates a new unary expression node with the given expression <code>r</code>
 * and terminal <code>k</code>.
 * @param r any expression.
 * @param k keyword terminal.
 */
  public MaximumExpression(Expression r, KeywordTerminal k) {
    super(r);
    this.k = k;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_UNARY_NONPARAMETRIC_MAXIMUM";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (k.getSpelling() + " " + k.getPosition());
  }
}