package pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.unary;

import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.terminals.OperatorTerminal;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.Expression;
import pl.edu.pjwstk.yaod.yaql.abstractsyntaxtree.expressions.NonParametricExpression;

/**
 * The <code>PreIncrementExpression</code> class represents the unary 
 * expression nodes in the abstract syntax tree.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class PreIncrementExpression extends NonParametricExpression {
  OperatorTerminal o;

/**
 * Creates a new unary expression node with the given expression <code>r</code>
 * and terminal <code>o</code>.
 * @param r any expression.
 * @param o operator terminal.
 */
  public PreIncrementExpression(Expression r, OperatorTerminal o) {
    super(r);
    this.o = o;
  }

/**
 * Returns the abstract syntax tree node type as a string value.
 * @return the abstract syntax tree node type as string.
 */
  public String getTypeAsString() {
    return "TYPE_EXPRESSION_UNARY_NONPARAMETRIC_PREINCREMENT";
  }

/**
 * Returns the spelling and positions of all terminals in a node.
 * @return the spelling and positions of all terminals in a node.
 */
  public String getSpellingAndPosition() {
    return (o.getSpelling() + " " + o.getPosition());
  }
}
