package pl.edu.pjwstk.yaod.yaql.engine;

import pl.edu.pjwstk.yaod.yaql.visitors.EvalException;

/**
 * The <code>EmptyStackException</code> class represents an exception which is
 * thrown if an error occurs during stack operations on empty stack. It possess
 * the reason of the error in <code>message</code> value.
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 * @see EvalException
 */
public class EmptyStackException extends EvalException {

/**
 * Creates a new exception with specified <code>message</code>.
 * @param message the message representing the error.
 */
  public EmptyStackException(String message) {
    super(message);
  }

/**
 * Returns the exception name.
 * @return the message representing the exception name.
 */
  public String getExceptionName() {
    return "EMPTY STACK ERROR";
  }
}