package pl.edu.pjwstk.yaod.yaql.visitors;

/**
 * The <code>BreakException</code> class represents an exception which is
 * thrown during program evaluation, when break statement occurs. 
 * @see BreakStatement
 * @see EvalException
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class BreakException extends EvalException {

/**
 * Creates a new break exception.
 */
  public BreakException() {
    super("");
  }

/**
 * Returns the exception name.
 * @return the message representing the exception name.
 */
  public String getExceptionName() {
    return "BREAK";
  }

/**
 * Returns the full exception message.
 * @return the message representing the reason of the exception.
 */
  public String getFullMessage() {
    return getExceptionName() + ": " + getMessage();
  }
}