package pl.edu.pjwstk.yaod.yaql.visitors;

/**
 * The <code>EmptyReturnException</code> class represents an exception which is
 * thrown during program evaluation, when empty return statement occurs. 
 * @see EmptyReturnStatement
 * @see EvalException
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class EmptyReturnException extends EvalException {

/**
 * Creates a new empty return exception.
 */
  public EmptyReturnException() { 
    super(""); 
  }

/**
 * Returns the exception name.
 * @return the message representing the exception name.
 */
  public String getExceptionName() {
    return "EMPTY RETURN";
  }

/**
 * Returns the full exception message.
 * @return the message representing the reason of the exception.
 */
  public String getFullMessage() {
    return getExceptionName() + ": " + getMessage();
  }
}