package pl.edu.pjwstk.yaod.yaql.visitors;

import pl.edu.pjwstk.yaod.yaql.SBQLException;

/**
 * The <code>EvalException</code> class represents an exception which is
 * thrown if an error occurs during program evaluation. It possess
 * the reason of the error in <code>message</code> value.
 * @see SBQLException
 * @author Jakub Trzetrzelewski, jakub_trzetrzelewski@yahoo.com
 * @version	1.0
 */
public class EvalException extends SBQLException {

/**
 * Creates a new exception with specified <code>message</code>.
 * @param message the message representing the error.
 */
  public EvalException(String message) {
    super(message);
  }

/**
 * Returns the exception name.
 * @return the message representing the exception name.
 */
  public String getExceptionName() {
    return "EVALUATION ERROR";
  }

/**
 * Returns the full exception message.
 * @return the message representing the reason of the exception.
 */
  public String getFullMessage() {
    return getExceptionName() + ": " + getMessage();
  }
}